diff --git a/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java b/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
new file mode 100644
index 000000000..f1f2fb8df
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
@@ -0,0 +1,132 @@
+package net.minecraft.client.render.terrain;
+
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
+import org.lwjgl.opengl.GL11;
+
+import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.RenderBlocks;
+import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkCache;
+
+public class ChunkRendererLegacy extends ChunkRenderer {
+
+	public ChunkRendererLegacy(World world, List<BlockEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
+		super(world, globalRenderableTileEntities, x, y, z, size, lists);
+	}
+
+	@Override
+    public void rebuild()
+    {
+        if(!dirty) { return; }
+        updates++;
+        final int minX = posX;
+        final int minY = posY;
+        final int minZ = posZ;
+        final int maxX = posX + sizeX;
+        final int maxY = posY + sizeY;
+        final int maxZ = posZ + sizeZ;
+        for(int i = 0; i < MAX_RENDER_PASSES; i++) { empty[i] = true; }
+
+        Chunk.isLit = false;
+        final Set<BlockEntity> lastSpecialTileEntities = new HashSet<>(renderableBlockEntities);
+        renderableBlockEntities.clear();
+        final int cacheRadius = 1;
+        final ChunkCache chunkcache = new ChunkCache(world, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
+        final RenderBlocks renderblocks = new RenderBlocks(chunkcache);
+        BlockModel.setRenderBlocks(renderblocks);
+        int renderPass = 0;
+        Tessellator tessellator = Tessellator.instance;
+        do
+        {
+            if(renderPass >= MAX_RENDER_PASSES) { break; }
+
+            boolean needsMoreRenderPasses = false;
+            boolean hasRenderedBlock = false;
+            boolean hasStartedDrawing = false;
+
+            for(int y = minY; y < maxY; y++)
+            {
+                for(int z = minZ; z < maxZ; z++)
+                {
+                    for(int x = minX; x < maxX; x++)
+                    {
+                        final int blockId = chunkcache.getBlockId(x, y, z);
+                        if(blockId <= 0) {
+                            continue;
+                        }
+                        if(!hasStartedDrawing) {
+                            hasStartedDrawing = true;
+                            GL11.glNewList(lists + renderPass, GL11.GL_COMPILE);
+                            GL11.glPushMatrix();
+                            translateToPos();
+                            final float scale = 1.000001F;
+                            GL11.glTranslatef((float)(-sizeZ) / 2.0F, (float)(-sizeY) / 2.0F, (float)(-sizeZ) / 2.0F);
+                            GL11.glScalef(scale, scale, scale);
+                            GL11.glTranslatef((float) sizeZ / 2.0F, (float) sizeY / 2.0F, (float) sizeZ / 2.0F);
+                            tessellator.startDrawingQuads();
+                            tessellator.setTranslation(-this.posX, -this.posY, -this.posZ);
+                            
+                            if(LightmapHelper.isLightmapEnabled()) {
+                            	// Make sure it's active
+                            	tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+                            }
+                        }
+                        if(renderPass == 0 && Block.isEntityTile[blockId]) {
+                            final BlockEntity tileentity = chunkcache.getBlockEntity(x, y, z);
+                            if(BlockEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
+                                renderableBlockEntities.add(tileentity);
+                            }
+                        }
+                        final Block block = Block.blocksList[blockId];
+                        final int blockRenderPass = block.getRenderLayer();
+                        if(blockRenderPass != renderPass) {
+                            needsMoreRenderPasses = true;
+                        }
+                        else {
+                        	if(LightmapHelper.isLightmapEnabled()) {
+                        		// Can probably be removed once all block models support the lightmap
+                        		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
+                        	}
+
+    						hasRenderedBlock |= renderBlock(tessellator, renderblocks, block, x, y, z);
+                        }
+                    }
+                }
+            }
+            if(hasStartedDrawing) {
+                tessellator.draw();
+                GL11.glPopMatrix();
+                GL11.glEndList();
+                tessellator.setTranslation(0.0D, 0.0D, 0.0D);
+            } else {
+                hasRenderedBlock = false;
+            }
+            
+            if(hasRenderedBlock) {
+                empty[renderPass] = false;
+            }            
+            if(!needsMoreRenderPasses) {
+                break;
+            }
+            
+            renderPass++;
+        } while(true);
+        HashSet<BlockEntity> newSpecialTileEntities = new HashSet<>(renderableBlockEntities);
+        newSpecialTileEntities.removeAll(lastSpecialTileEntities);
+        globalRenderableBlockEntities.addAll(newSpecialTileEntities);
+        renderableBlockEntities.forEach(lastSpecialTileEntities::remove);
+        globalRenderableBlockEntities.removeAll(lastSpecialTileEntities);
+        skyLit = Chunk.isLit;
+        compiled = true;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
new file mode 100644
index 000000000..6dad6b056
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -0,0 +1,158 @@
+package net.minecraft.client.render.terrain;
+
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
+import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.RenderBlocks;
+import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.culling.CameraFrustum;
+import net.minecraft.client.render.terrain.VertexBuffer.Entry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorStandard;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkCache;
+
+public class ChunkRendererMultiDraw extends ChunkRenderer {
+
+	public final TerrainRendererMultiDraw terrainRenderer;
+	public final Entry[] renderListEntries;
+	
+	public ChunkRendererMultiDraw(TerrainRendererMultiDraw terrainRenderer, World world, List<BlockEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
+		super(world, globalRenderableTileEntities, x, y, z, size, lists);
+		
+		if(terrainRenderer == null) {
+			throw new NullPointerException("TerrainRenderer is null!");
+		}
+		
+		this.terrainRenderer = terrainRenderer;
+		this.renderListEntries = new Entry[terrainRenderer.MAX_RENDER_PASSES];
+	}
+	
+	@Override
+	public void rebuild() {
+		if(!dirty) {
+			return;
+		}
+		
+		updates++;
+		
+		final int minX = posX;
+		final int minY = posY;
+		final int minZ = posZ;
+		
+		final int maxX = posX + sizeX;
+		final int maxY = posY + sizeY;
+		final int maxZ = posZ + sizeZ;
+		
+		final int renderPassCount = terrainRenderer.MAX_RENDER_PASSES;
+		
+		terrainRenderer.chunkDeleted(this);
+		
+		Chunk.isLit = false;
+		final Set<BlockEntity> lastSpecialTileEntities = new HashSet<>(renderableBlockEntities);
+		renderableBlockEntities.clear();
+		
+		final int cacheRadius = 1;
+		final ChunkCache chunkCache = new ChunkCache(world, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
+		final RenderBlocks renderBlocks = new RenderBlocks(chunkCache);
+		BlockModel.setRenderBlocks(renderBlocks);
+		
+		TessellatorStandard tessellator = (TessellatorStandard) Tessellator.instance;
+		for(int renderPass = 0; renderPass < renderPassCount; renderPass++) {
+			boolean needsMoreRenderPasses = false;
+			boolean hasRenderedBlock = false;
+			boolean hasStartedDrawing = false;
+
+			for(int y = minY; y < maxY; y++) {
+				for(int z = minZ; z < maxZ; z++) {
+					for(int x = minX; x < maxX; x++) {
+						final int blockId = chunkCache.getBlockId(x, y, z);
+						if(blockId <= 0) {
+							continue;
+						}
+						if(!hasStartedDrawing) {
+							hasStartedDrawing = true;
+							tessellator.startDrawingQuads();
+//							tessellator.setTranslation(-this.posX, -this.posY, -this.posZ);
+							
+							RenderRegion region = terrainRenderer.getRenderRegionAtBlockPos(posX, posZ);
+							tessellator.setTranslation(-(region.posX << terrainRenderer.REGION_SIZE), 0.0, -(region.posZ << terrainRenderer.REGION_SIZE));
+							
+							if(LightmapHelper.isLightmapEnabled()) {
+								// Make sure it's active
+								tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+							}
+							tessellator.setColorRGBA(255, 255, 255, 255);
+							tessellator.setTextureUV(0.0, 0.0);
+						}
+						if(renderPass == 0 && Block.isEntityTile[blockId]) {
+							final BlockEntity tileentity = chunkCache.getBlockEntity(x, y, z);
+							if(BlockEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
+								renderableBlockEntities.add(tileentity);
+							}
+						}
+						final Block block = Block.blocksList[blockId];
+						final int blockRenderPass = block.getRenderLayer();
+						
+						if(blockRenderPass != renderPass) {
+							needsMoreRenderPasses = true;
+							continue;
+						}
+						
+						hasRenderedBlock |= renderBlock(tessellator, renderBlocks, block, x, y, z);
+					}
+				}
+			}
+			if(hasStartedDrawing) {
+				terrainRenderer.chunkRendered(this, tessellator, renderPass);
+				tessellator.setTranslation(0.0, 0.0, 0.0);
+			}else {
+				hasRenderedBlock = false;
+			}
+
+			if(hasRenderedBlock) {
+				empty[renderPass] = false;
+			}
+			if(!needsMoreRenderPasses) {
+				break;
+			}
+		}
+		
+		HashSet<BlockEntity> newSpecialTileEntities = new HashSet<>(renderableBlockEntities);
+		newSpecialTileEntities.removeAll(lastSpecialTileEntities);
+		globalRenderableBlockEntities.addAll(newSpecialTileEntities);
+		renderableBlockEntities.forEach(lastSpecialTileEntities::remove);
+		globalRenderableBlockEntities.removeAll(lastSpecialTileEntities);
+		skyLit = Chunk.isLit;
+		compiled = true;
+	}
+	
+	@Override
+	public void cull(CameraFrustum frustum, float partialTick) {
+		boolean wasVisible = this.visible;
+		super.cull(frustum, partialTick);
+		if(wasVisible != visible) {
+			terrainRenderer.chunkVisibilityChanged(this);
+		}
+	}
+	
+	@Override
+	public void reset() {
+		// TerrainRenderer is null during initialization
+		if(terrainRenderer != null) {
+			terrainRenderer.chunkDeleted(this);	
+		}
+		super.reset();
+	}
+	
+	@Override
+	public String toString() {
+		return "[" + posX + "," + posY + "," + posZ + "]";
+	}
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java b/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
new file mode 100644
index 000000000..3da683cfd
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/RegionBuffer.java
@@ -0,0 +1,67 @@
+package net.minecraft.client.render.terrain;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+public class RegionBuffer {
+	
+	public final int regionSizeShift;
+	
+	private final Map<Integer, RenderRegion> regionMap = new HashMap<>();
+	private final List<RenderRegion> regionList = new ArrayList<>();
+	private final List<RenderRegion> immutableRegionList = Collections.unmodifiableList(regionList);
+	
+	public RegionBuffer(int regionSizeShift) {
+		this.regionSizeShift = regionSizeShift;
+	}
+	
+	public RenderRegion getRegionAtBlockPos(int blockX, int blockZ) {
+		int x = blockX >> regionSizeShift;
+		int z = blockZ >> regionSizeShift;
+		return getRegion(x, z);
+	}
+	
+	public RenderRegion getRegion(int x, int z) {
+		int index = getIndex(x, z);
+		
+		RenderRegion region = regionMap.get(index);
+		if(region == null) {
+			region = new RenderRegion(x, z);
+			regionMap.put(index, region);
+			regionList.add(region);
+		}else {
+			if(region.posX != x || region.posZ != z) {
+				throw new RuntimeException(region + " != " + new RenderRegion(x, z));
+			}	
+		}
+		return region;
+	}
+	
+	public void remove(RenderRegion region) {
+		int index = getIndex(region.posX, region.posZ);
+		
+		RenderRegion existingRegion = regionMap.get(index);
+		if(existingRegion != region) {
+			throw new RuntimeException(region + " != " + existingRegion);
+		}
+		
+		regionMap.remove(index);
+		regionList.remove(region);
+	}
+	
+	public int getIndex(int x, int z) {
+		return ((x & 0xFFFF) << 16) | (z & 0xFFFF);
+	}
+	
+	public List<RenderRegion> getAllRegions() {
+		return immutableRegionList;
+	}
+	
+	public int size() {
+		return regionMap.size();
+	}
+	
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/render/terrain/RenderList.java b/src/main/java/net/minecraft/client/render/terrain/RenderList.java
new file mode 100644
index 000000000..6e428881a
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/RenderList.java
@@ -0,0 +1,160 @@
+package net.minecraft.client.render.terrain;
+
+import static org.lwjgl.opengl.GL15.*;
+
+import java.nio.IntBuffer;
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
+import net.minecraft.client.render.terrain.VertexBuffer.Entry;
+import net.minecraft.core.util.helper.Buffer;
+
+/**
+ * 		Can render a lot of objects with a single call
+ * <br> All objects need to have the same {@link VertexConfig}
+ * <br> Entries can be toggled visible or invisible quickly
+ */
+public class RenderList {
+	
+	public final VertexBuffer vertexBuffer;
+	
+	private VertexConfig vertexConfig;
+	private boolean vertexConfigLocked = false;
+	
+	private IntBuffer posBuffer;
+	private IntBuffer sizeBuffer;
+	
+	private List<Entry> entryList = new ArrayList<>();
+	private Set<Entry> visibleEntries = new HashSet<>();
+	
+	private boolean visibleEntriesUpdated = true;
+	
+	public RenderList(VertexBuffer vertexBuffer, int capacity) {
+		this.vertexBuffer = vertexBuffer;
+		this.posBuffer = Buffer.createBuffer(capacity * 4).asIntBuffer();
+		this.sizeBuffer = Buffer.createBuffer(capacity * 4).asIntBuffer();
+	}
+	
+	public void draw() {
+		if(entryList.size() == 0) {
+//			System.out.println("No Entries!");
+			return;
+		}
+		
+		if(visibleEntriesUpdated) {
+			int vertexSize = vertexConfig.getVertexSize();
+			
+			posBuffer = expandIfNecessary(posBuffer, visibleEntries.size());
+			sizeBuffer = expandIfNecessary(sizeBuffer, visibleEntries.size());
+			
+			posBuffer.clear();
+			sizeBuffer.clear();
+			
+			for(Entry entry : visibleEntries) {
+				posBuffer.put(entry.position / vertexSize);
+				sizeBuffer.put(entry.size / vertexSize);
+			}
+			
+			posBuffer.flip();
+			sizeBuffer.flip();
+			
+			visibleEntriesUpdated = false;
+		}
+		
+		if(visibleEntries.size() == 0) {
+//			System.out.println("No Visible Entries!");
+			return;
+		}
+		
+//		System.out.println("Rendering " + visibleEntries.size() + " entries");
+		glMultiDrawArrays(vertexConfig.drawMode, posBuffer, sizeBuffer);
+	}
+	
+	public Entry add(VertexData vertexData, boolean visible) {
+		if(vertexData.vertexCount <= 0) {
+			return null;
+		}
+		
+		if(entryList.size() == 0 && !vertexConfigLocked) {
+			this.vertexConfig = vertexData.config.copy();
+		}else {
+			VertexConfig.compareThrow(vertexConfig, vertexData.config);
+		}
+		
+		Entry entry = vertexBuffer.addVertexData(vertexData);
+		entryList.add(entry);
+		
+		if(visible) {
+			visibleEntries.add(entry);
+			visibleEntriesUpdated = true;
+		}
+		
+		return entry;
+	}
+	
+	public void setVisible(Entry entry, boolean visible) {
+		if(entry == null) {
+			throw new NullPointerException();
+		}
+		if(visible) {
+			if(visibleEntries.add(entry)) {
+				visibleEntriesUpdated = true;
+			}
+		}else {
+			if(visibleEntries.remove(entry)) {
+				visibleEntriesUpdated = true;
+			}
+		}
+	}
+	
+	public void lockVertexConfig(VertexConfig vertexConfig) {
+		if(vertexConfig == null) {
+			throw new NullPointerException("VertexConfig cannot be null!");
+		}
+		if(entryList.size() > 0 && !this.vertexConfig.equals(vertexConfig)) {
+			VertexConfig.compareThrow(this.vertexConfig, vertexConfig);
+		}
+		this.vertexConfig = vertexConfig.copy();
+		this.vertexConfigLocked = true;
+	}
+	
+	public boolean remove(Entry entry) {
+		if(entryList.remove(entry)) {
+			vertexBuffer.removeEntry(entry);
+			visibleEntries.remove(entry);
+			visibleEntriesUpdated = true;
+			return true;
+		}
+		return false;
+	}
+	
+	public int size() {
+		return entryList.size();
+	}
+	
+	public int visibleEntryCount() {
+		return visibleEntries.size();
+	}
+	
+	public VertexConfig getVertexConfig() {
+		return vertexConfig;
+	}
+	
+	public boolean isVertexConfigLocked() {
+		return vertexConfigLocked;
+	}
+	
+	public static IntBuffer expandIfNecessary(IntBuffer buffer, int requiredCapacity) {
+		if(buffer.capacity() < requiredCapacity) {
+			int newCapacity = Math.max(buffer.capacity() * 2, requiredCapacity);
+			
+			System.out.println("Expand RenderList IntBuffer " + buffer.capacity() + " -> " + newCapacity);
+			
+			return Buffer.createBuffer(newCapacity << 2).asIntBuffer();
+		}
+		return buffer;
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/RenderRegion.java b/src/main/java/net/minecraft/client/render/terrain/RenderRegion.java
new file mode 100644
index 000000000..5a1d2f619
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/RenderRegion.java
@@ -0,0 +1,30 @@
+package net.minecraft.client.render.terrain;
+
+public class RenderRegion {
+	
+	public final int posX;
+	public final int posZ;
+	
+	public RenderList[] renderLists = new RenderList[2];
+	
+	public RenderRegion(int posX, int posZ) {
+		this.posX = posX;
+		this.posZ = posZ;
+	}
+	
+	public boolean hasRenderData() {
+		for(int i=0; i < renderLists.length; i++) {
+			RenderList renderList = renderLists[i];
+			if(renderList != null && renderList.size() > 0) {
+				return true;
+			}
+		}
+		return false;
+	}
+
+	@Override
+	public String toString() {
+		return "[" + posX + "," + posZ + "]";
+	}
+	
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/render/terrain/TerrainRenderPass.java b/src/main/java/net/minecraft/client/render/terrain/TerrainRenderPass.java
new file mode 100644
index 000000000..c9e75e2ac
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/TerrainRenderPass.java
@@ -0,0 +1,5 @@
+package net.minecraft.client.render.terrain;
+
+public class TerrainRenderPass {
+
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java b/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
new file mode 100644
index 000000000..19ca2f610
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.render.terrain;
+
+import java.util.List;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.world.World;
+
+public abstract class TerrainRenderer {
+	
+	public final Minecraft mc;
+	
+	public TerrainRenderer(Minecraft minecraft) {
+		this.mc = minecraft;
+	}
+	
+	public abstract void renderSolidTerrain(float partialTicks);
+	
+	public abstract void renderTranslucentTerrain(float partialTicks);
+	
+	public abstract ChunkRenderer createChunkRenderer(World world, List<BlockEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists);
+
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/TerrainRendererLegacy.java b/src/main/java/net/minecraft/client/render/terrain/TerrainRendererLegacy.java
new file mode 100644
index 000000000..b1dd01cd8
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/TerrainRendererLegacy.java
@@ -0,0 +1,44 @@
+package net.minecraft.client.render.terrain;
+
+import static org.lwjgl.opengl.GL11.*;
+
+import java.util.List;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.RenderGlobal;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.world.World;
+
+public class TerrainRendererLegacy extends TerrainRenderer {
+
+	public TerrainRendererLegacy(Minecraft minecraft) {
+		super(minecraft);
+	}
+
+	@Override
+	public void renderSolidTerrain(float partialTicks) {
+        mc.renderGlobal.sortAndRender(mc.activeCamera, 0, partialTicks);
+	}
+
+	@Override
+	public void renderTranslucentTerrain(float partialTicks) {
+		RenderGlobal renderGlobal = mc.renderGlobal;
+		if(mc.gameSettings.fancyGraphics.value == 0) {
+			renderGlobal.sortAndRender(mc.activeCamera, 1, partialTicks);
+			return;
+		}
+		
+		glColorMask(false, false, false, false);
+		int renderCount = renderGlobal.sortAndRender(mc.activeCamera, 1, partialTicks);
+		glColorMask(true, true, true, true);
+		
+		if(renderCount > 0) {
+			renderGlobal.callAllDisplayLists(1, partialTicks);
+		}
+	}
+
+	@Override
+	public ChunkRenderer createChunkRenderer(World world, List<BlockEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
+		return new ChunkRendererLegacy(world, globalRenderableTileEntities, x, y, z, size, lists);
+	}
+}
diff --git a/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java b/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
new file mode 100644
index 000000000..e7f0b6cfa
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
@@ -0,0 +1,269 @@
+package net.minecraft.client.render.terrain;
+
+import static org.lwjgl.opengl.GL11.*;
+
+import java.util.List;
+
+import org.lwjgl.opengl.GL11;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.terrain.VertexBuffer.Entry;
+import net.minecraft.client.render.tessellator.TessellatorStandard;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class TerrainRendererMultiDraw extends TerrainRenderer {
+
+	public final int VERTEX_BUFFER_INITIAL_CAPACITY = 67108864;
+	
+	public final int RENDER_LIST_INITIAL_CAPACITY = 2048;
+	
+	/**
+	 * Exponential Region Size
+	 * Lower Region Size: More Draw Calls, reduced FPS
+	 * Higher Region Size: More Visual Artifacts
+	 */
+	public final int REGION_SIZE = 9;
+	
+	public final int MAX_RENDER_PASSES = 2;
+	
+	/**
+	 * For debugging purposes
+	 */
+	public final boolean DISABLE_REGION_OFFSET = false;
+	
+	public VertexBuffer vertexBuffer;
+	public RegionBuffer regionBuffer;
+	
+	private VertexConfig terrainVertexConfig;
+	
+	int[] drawCalls = new int[MAX_RENDER_PASSES];
+	
+	private double renderPosX;
+	private double renderPosY;
+	private double renderPosZ;
+
+	private double prevSortX;
+	private double prevSortY;
+	private double prevSortZ;
+	
+	public TerrainRendererMultiDraw(Minecraft minecraft) {
+		super(minecraft);
+		
+		vertexBuffer = new VertexBuffer(VERTEX_BUFFER_INITIAL_CAPACITY);
+		regionBuffer = new RegionBuffer(REGION_SIZE);
+	}
+	
+	@Override
+	public void renderSolidTerrain(float partialTicks) {
+		for(int i=0; i < drawCalls.length; i++) {
+			drawCalls[i] = 0;
+		}
+
+		ICamera camera = mc.activeCamera;
+		renderPosX = camera.getX(partialTicks);
+		renderPosY = camera.getY(partialTicks);
+		renderPosZ = camera.getZ(partialTicks);
+
+		double dX = renderPosX - prevSortX;
+		double dY = renderPosY - prevSortY;
+		double dZ = renderPosZ - prevSortZ;
+
+		if(dX * dX + dY * dY + dZ * dZ > 16.0) {
+			prevSortX = renderPosX;
+			prevSortY = renderPosY;
+			prevSortZ = renderPosZ;
+			
+			int x = MathHelper.floor(renderPosX);
+			int y = MathHelper.floor(renderPosY);
+			int z = MathHelper.floor(renderPosZ);
+			
+			mc.renderGlobal.markRenderersForNewPosition(x, y, z);
+		}
+		
+		if(terrainVertexConfig == null) {
+			return;
+		}
+		
+		glPushMatrix();
+		glTranslated(-renderPosX, -renderPosY, -renderPosZ);
+		
+		terrainVertexConfig.enableVBO(vertexBuffer.getVbo());
+		
+		List<RenderRegion> regions = regionBuffer.getAllRegions();
+		for(int i=0; i < regions.size(); i++) {
+			RenderRegion region = regions.get(i);
+			// TODO Clear empty regions, but not like this
+//			if(!region.hasRenderData()) {
+//				regionBuffer.remove(region);
+//				i--;
+//				continue;
+//			}
+
+			RenderList renderList = region.renderLists[0];
+			if(renderList != null && renderList.size() > 0) {
+				if(!DISABLE_REGION_OFFSET) {
+					glPushMatrix();
+					glTranslated((region.posX << REGION_SIZE), 0.0, (region.posZ << REGION_SIZE));
+				}
+				
+				renderList.draw();
+				drawCalls[0]++;
+				
+				if(!DISABLE_REGION_OFFSET) {
+					glPopMatrix();
+				}
+			}
+		}
+		
+		terrainVertexConfig.disable();
+		
+		glPopMatrix();
+		
+	}
+	
+	public void renderAllLists(int renderPass) {
+		List<RenderRegion> regions = regionBuffer.getAllRegions();
+		for(int i=0; i < regions.size(); i++) {
+			RenderRegion region = regions.get(i);
+			RenderList renderList = region.renderLists[renderPass];
+			if(renderList != null && renderList.size() > 0) {
+				if(!DISABLE_REGION_OFFSET) {
+					glPushMatrix();
+					glTranslated((region.posX << REGION_SIZE), 0.0, (region.posZ << REGION_SIZE));
+				}
+				
+				renderList.draw();
+				drawCalls[renderPass]++;
+				
+				if(!DISABLE_REGION_OFFSET) {
+					glPopMatrix();
+				}
+			}
+		}
+	}
+
+	@Override
+	public void renderTranslucentTerrain(float partialTicks) {
+		if(terrainVertexConfig == null) {
+			return;
+		}
+		
+		glPushMatrix();
+		glTranslated(-renderPosX, -renderPosY, -renderPosZ);
+		
+		terrainVertexConfig.enableVBO(vertexBuffer.getVbo());
+		
+		boolean fancy = mc.gameSettings.fancyGraphics.value != 0;
+		
+		if(fancy) {
+			GL11.glColorMask(false, false, false, false);
+		}
+		
+		renderAllLists(1);
+		
+		if(fancy) {
+			GL11.glColorMask(true, true, true, true);
+			if(drawCalls[1] > 0) {
+				renderAllLists(1);
+			}
+		}
+		
+		terrainVertexConfig.disable();
+		
+		glPopMatrix();
+	}
+	
+	public void chunkRendered(ChunkRendererMultiDraw chunkRenderer, TessellatorStandard tessellator, final int renderPass) {
+		tessellator.drawing = false;
+		VertexConfig config = tessellator.data.config;
+		
+		if(terrainVertexConfig == null) {
+			this.terrainVertexConfig = config.copy();
+		}else {
+			if(!this.terrainVertexConfig.equals(tessellator.data.config)) {
+				List<RenderRegion> allRegions = regionBuffer.getAllRegions();
+				for(int i=0; i < allRegions.size(); i++) {
+					RenderRegion region = allRegions.get(i);
+					if(region.hasRenderData()) {
+						VertexConfig.compareThrow(tessellator.data.config, terrainVertexConfig);
+					}
+					regionBuffer.remove(region);
+					i--;
+				}
+				
+				this.terrainVertexConfig = config.copy();
+			}
+		}
+		
+		RenderList renderList = getOrCreateRenderList(chunkRenderer, renderPass);
+		Entry entry = renderList.add(tessellator.data, chunkRenderer.visible);
+		chunkRenderer.renderListEntries[renderPass] = entry;
+	}
+	
+	public void chunkVisibilityChanged(ChunkRendererMultiDraw chunkRenderer) {
+		RenderRegion region = getRenderRegionAtBlockPos(chunkRenderer.posX, chunkRenderer.posZ);
+		
+		for(int renderPass=0; renderPass < MAX_RENDER_PASSES; renderPass++) {
+			Entry entry = chunkRenderer.renderListEntries[renderPass];
+			if(entry == null) {
+				continue;
+			}
+			RenderList renderList = region.renderLists[renderPass];
+			if(renderList == null) {
+				throw new NullPointerException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
+			}
+			renderList.setVisible(entry, chunkRenderer.visible);
+		}
+	}
+	
+	public void chunkDeleted(ChunkRendererMultiDraw chunkRenderer) {
+		RenderRegion region = getRenderRegionAtBlockPos(chunkRenderer.posX, chunkRenderer.posZ);
+		for(int renderPass=0; renderPass < MAX_RENDER_PASSES; renderPass++) {
+			Entry entry = chunkRenderer.renderListEntries[renderPass];
+			if(entry == null) {
+				continue;
+			}
+			RenderList renderList = region.renderLists[renderPass];
+			if(renderList == null) {
+				throw new NullPointerException("Region " + region + " does not have a render list for render pass " + renderPass + "!");
+			}
+			renderList.remove(entry);
+			chunkRenderer.renderListEntries[renderPass] = null;
+		}
+	}
+	
+	public RenderList getOrCreateRenderList(ChunkRendererMultiDraw chunkRenderer, final int renderPass) {
+		return getOrCreateRenderList(chunkRenderer.posX, chunkRenderer.posZ, renderPass);
+	}
+	
+	public RenderList getOrCreateRenderList(int posX, int posZ, final int renderPass) {
+		RenderRegion region = regionBuffer.getRegionAtBlockPos(posX, posZ);
+		RenderList renderList = region.renderLists[renderPass];
+		if(renderList == null) {
+			renderList = new RenderList(vertexBuffer, RENDER_LIST_INITIAL_CAPACITY);
+			region.renderLists[renderPass] = renderList;
+		}
+		return renderList;
+	}
+
+	@Override
+	public ChunkRenderer createChunkRenderer(World world, List<BlockEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists) {
+		return new ChunkRendererMultiDraw(this, world, globalRenderableTileEntities, x, y, z, size, lists);
+	}
+	
+	public RenderRegion getRenderRegionAtBlockPos(int blockX, int blockZ) {
+		return regionBuffer.getRegionAtBlockPos(blockX, blockZ);
+	}
+	
+	public int getTotalDrawCalls() {
+		int totalDrawCalls = 0;
+		for(int i=0; i < drawCalls.length; i++) {
+			totalDrawCalls += drawCalls[i];
+		}
+		return totalDrawCalls;
+	}
+	
+}
